#!/usr/local/bin/perl -w

# Halve.pl

# SPECIFICATIONS

# System (Mac, UNIX, or PC)

$System = 'Mac';

# File (input)

$Input = '10x10';

# Directory (output)

$OutputDirectory = 'Halved';

# END SPECIFICATIONS

# Print introduction

print "Halve: Recursively halve the records in a file.\n\n";

# Select directory character

$System = uc($System);	# Make all upper-case
if($System eq 'MAC') { $Dir = ':' }
elsif($System eq 'UNIX') { $Dir = '/' }
elsif($System eq 'PC') { $Dir = '\\' }
else { die "Error: Directory character for $System not known\n" }

# Make path to directory

$OutputPath = $Dir.$OutputDirectory.$Dir;
unless($System eq 'MAC') { $OutputPath = '.'.$OutputPath }

# Make output directory

mkdir($OutputDirectory, 0770);

# Show specifications

print "Specifications:\n\n";

print "$System version.\n\n";

print "Input file: $Input.\n";
print "Output directory: $OutputDirectory.\n\n";

# Halve

$Old = "$Input";
print "<- $Old\n";
$New = $Old;
$Counter = 2;

while($Counter > 1)
{
	open(IN, "$New") or die "Can't read $New";
	@List = <IN>;
	close(IN);
	
	$Counter = 0;
	$Output = '';
	
	for($i = 0; $i < @List; $i += 2)
	{
		$Output = $Output.$List[$i];
		$Counter += 1;
	}
	
	$New = "$OutputPath$Old ($Counter)";
	print "-> $New\n";
	open(OUT, ">$New") or die "Can't write $New";
	print OUT $Output;
	close(OUT);
}

# Print end message

$Duration = time - $^T;

print "\nHalve finished in $Duration seconds.\n";
