#!/usr/local/bin/perl -w

# Random.pl

$Max = 100;
$Min = 1;

# Print introduction

print "Generate a data matrix of R rows x C columns.\n";
print "Entries are ones or zeros selected at random.\n";
print "Maximum dimensions: $Max x $Max.\n";
print "Minimum dimensions: $Min x $Min.\n\n";

# Obtain specifications

print "Enter the number of rows (R):\n";

$Rows = &GetInt;

print "Enter the number of columns (C):\n";

$Columns = &GetInt;

print "Enter a name for the data matrix:\n";

$Output = &GetName;

# Create matrix

@Matrix = ();
srand();

for($R = 0; $R < $Rows; $R += 1)
{
	for($C = 0; $C < $Columns; $C += 1)
	{ $Matrix[$R][$C] = int(rand(2)) }
}

# Write output

open(OUTPUT, ">$Output") or die "Can't write to $Output";

for($R = 0; $R <= $Rows; $R += 1)
{ print OUTPUT join("\t", @{$Matrix[$R]}), "\n" }

# End
	
print "\nRandom finished.\n";

sub GetInt
{	
	$In = <STDIN>;
	chomp($In);
	$In = int($In);
	
	if(($In > $Max) or ($In < $Min))
	{
		print "Enter a number between $Min and $Max:\n";
		&GetInt;
	}
	
	return $In;
}

sub GetName
{	
	$In = <STDIN>;
	chomp($In);
	
	if(length($In) > 8)
	{
		print "Enter a name with 8 or less characters:\n";
		&GetName;
	}
	
	return $In;
}
